



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于Struts2框架实现登录案例 之 程序国际化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于Struts2框架实现登录案例 之 程序国际化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 00:32:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>国际化牵涉的知识非常多，这里只能简单的介绍，程序国际化的一般做法是：在jsp页面时，</p>
<p>不是直接输出信息，而是输出一个key值，该key值在不同语言环境下找到对应资源文件下的</p>
<p>对应信息，因此首先要创建满足不同国家或地域用户的资源文件。</p>
<p>1） 创建国际化资源文件 <br />          　　资源文件的命名规则：basename_语言代码_国家代码.properties，文件中包含一些键值对。<br />          　　A、语言代码_国家代码：zh_CN、en_US等。<br />          　　B、国际资源文件放在classes文件夹下。</p>
<p><strong>　　MessageResourc<strong>e</strong>_zh_CN.properties</strong></p>
<p><strong>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914164949726-502101412.jpg" /></strong></p>
<p>　　<strong>MessageResource_en_US.properties</strong></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914165135679-1845011823.jpg" /></p>
<p>2）加载资源文件<br />          　　Struts2提供非常多的加载国际化资源文件的方式，但最为常用的是加载全局的资源文件，具体方法如下：<br />          　　A、配置struts.xml文件，添加一个struts.custom.i18n.resources常量。 形如：<br />               　　　　&lt;constant name="struts.custom.i18n.resources" value="资源文件basename"&gt;&lt;/constant&gt;<br />          　　B、创建struts.properties文件，添加一个struts.custom.i18n.resources常量。形如：<br />               　　　　struts.custom.i18n.resources=资源文件basename</p>
<div>
<pre class="prettyprint linenums"> &lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
 &lt;!DOCTYPE struts PUBLIC<br />
     "-//Apache Software Foundation//DTD Struts Configuration 2.3//EN"<br />
     "http://struts.apache.org/dtds/struts-2.3.dtd"&gt;

 &lt;struts&gt;<br />
     <strong>&lt;constant name="struts.custom.i18n.resources" value="MessageResource"&gt;&lt;/constant&gt;</strong><br />
     &lt;package name="mypack" extends="struts-default"&gt;<br />
         &lt;action name="first"&gt;<br />
             &lt;result&gt;first.jsp&lt;/result&gt;<br />
         &lt;/action&gt;<br />
     &lt;/package&gt;

     &lt;!-- Action必须放在指定的包空间中 --&gt;<br />
     &lt;package name="struts2" extends="struts-default"&gt;<br />
         &lt;!-- 定义login的action，其实现类为com.mhb.action.LoginAction --&gt;<br />
         &lt;action name="userlogin" class="com.mhb.action.LoginAction2"&gt;<br />
             &lt;!-- 定义处理结果与视图资源之间的关系 --&gt;<br />
             &lt;result name="success"&gt;/login_success.jsp&lt;/result&gt;<br />
             &lt;result name="failure"&gt;/login_failure.jsp&lt;/result&gt;<br />
             &lt;result name="input"&gt;/login2.jsp&lt;/result&gt;<br />
         &lt;/action&gt;<br />
     &lt;/package&gt;<br />
 &lt;/struts&gt;</pre>
</div>
<p>3）应用国际资源文件<br />          　　A、输出国际化信息：&lt;s:text name="messageKey"&gt;<br />          　　B、表单标签国际化：通过指定key属性，即在表单中加：key="messageKey"<br />          　　C、校验信息国际化：在基于硬编码方式下，通过getText()方法指定key来获得国际化校验信息提示；</p>
<p>　　　　基于验证框架下用message标签中的key属性来实现。形式为</p>
<p>　　　　在没开启客户端验证情况下:&lt;message key="messageKey"&gt;&lt;/message&gt;<br />               　　　　在开启客户端验证情况下: &lt;message &gt;${getText("username.required")}&lt;/message&gt;</p>
<div>
<pre class="prettyprint linenums"> &lt;%@ page language="java" pageEncoding="utf-8"%&gt;<br />
 <strong>&lt;%@ taglib prefix="s" uri="/struts-tags" %&gt;</strong>

 &lt;html&gt;<br />
     &lt;body&gt;<br />
         &lt;center&gt;<br />
         <strong>&lt;h3&gt;&lt;s:text name="login.title"&gt;&lt;/s:text&gt;&lt;/h3&gt;</strong><br />
             &lt;%-- 登录表单，提交到login.action --%&gt;<br />
             &lt;s:form action="userlogin"&gt;<br />
                 &lt;%--用户名输入框--%&gt;<br />
                 <strong>&lt;s:textfield name="username" key="login.username"&gt;&lt;/s:textfield&gt;</strong><br />
                 &lt;%--用户密码输入框--%&gt;<br />
                <strong> &lt;s:password name="userpwd" key="login.userpwd"&gt;&lt;/s:password&gt;</strong><br />
                 &lt;%--登录按钮--%&gt;<br />
                 <strong>&lt;s:submit key="login.submit"&gt;&lt;/s:submit&gt;</strong><br />
                 &lt;%--重置按钮--%&gt;<br />
                 <strong>&lt;s:reset key="login.reset"&gt;&lt;/s:reset&gt;</strong><br />
             &lt;/s:form&gt;<br />
         &lt;/center&gt;<br />
     &lt;/body&gt;<br />
 &lt;/html&gt;</pre>
</div>
<p>浏览器效果，调整语言的先后顺序，依次设定显示中文和英文。</p>
<p>　　A：IE属性--常规--语言--〉中文：显示中文信息</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914170036758-721527184.jpg" /></p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914170147461-1303258841.jpg" /></p>
<p>　　B：IE属性--常规--英语（美国）--〉显示英文信息　　</p>
<p><strong>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914170337039-910113517.jpg" /></strong></p>
<p><strong>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/799698/201509/799698-20150914170442336-1392920545.jpg" /></strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1zepz9.html">javascript 技巧总结积累（正在积累中）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o5ddp9.html">Deep Learning 19&lowbar;深度学习UFLDL教程：Convolutional Neural Network&lowbar;Exercise（斯坦福大学深度学习教程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901kp38.html">&lbrack;转&rsqb;Using Entity Framework &lpar;EF&rpar; Code-First Migrations in nopCommerce for Fast Customizations</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv63y18.html">LinuxMint下Apache Http源码安装过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ror1d9.html">《数据结构与算法分析》学习笔记（四）&mdash;&mdash;栈ADT</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeed2z9.html">Oracle 11g安装步骤详谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1vp2g8.html">HTTP 500 的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn152kg8.html">&lbrack;MySQL&rsqb; 数据统计 &mdash;&mdash; 按周，按月，按日分组统计数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5p409.html">64bit Ubuntu&comma; Android AAPT&comma; R&period;java</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnynlpq.html">cocos2d-x lua table与json的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m1py1q.html">CSS3 box-shadow&lpar;阴影使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv41pzq.html">The secret of ROWID</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn66j9.html">JVM知识在离线数据中的运用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2zv1q.html">&lbrack;代码审计&rsqb;青云客Cms前台有条件注入至getshell，后台xss至getshell、至弹你一脸计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrwp09.html">clang如何获得程序控制流图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jo6no8.html">java的ArrayList源码摘要</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzy6rg8.html">CSAPP：第二章学习笔记：斗之气2段</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvd4wmq.html">Scala进阶之路-为什么要学习Scala以及开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pd043q.html">webpack处理url资源的配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pl4ynq.html">北京Uber优步司机奖励政策（4月15日）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyd5d4jq.html">SQLite数据库的加密【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2wnoq.html">Oracle 10g下载链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1j1nx9.html">Linux内核学习方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmkjj19.html">java排序集锦</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mgze1q.html">基于UUID生成短ID</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xvw2w9.html">iTween基础之Move&lpar;移动&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmk1g69.html">Maven实站读后感</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zlplz9.html">div 布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmkn309.html">centos 7 有点意思</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmknz69.html">POJ 3723 Conscription 最小生成树</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
